/*******************************************

				  7 QVGAʾ







**********************************************/


#include "fsmc_sram.h"

#define Bank1_LCD_D    ((uint32_t)0x60020000)    //disp Data ADDR
#define Bank1_LCD_C    ((uint32_t)0x60000000)	 //disp Reg ADDR

unsigned long color1=0;
//void MUC_Init();
void SSD1963_Init(void);
void LCD_WR_REG(unsigned int index);
void LCD_WR_CMD(unsigned int index,unsigned int val);

void LCD_WR_Data(unsigned int val);
void LCD_WR_Data_8(unsigned int val);
void LCD_test(void);
//void LCD_clear(unsigned int p);
void ini(void);

void lcd_wr_zf(unsigned int a, unsigned int b, unsigned int a1,unsigned int b1, unsigned int d,unsigned int e, unsigned char g, unsigned char *f); 
void lcd_wr_pixel(unsigned int a, unsigned int b, unsigned int e) ;
unsigned char *num_pub(unsigned int a);
void LCD_clear(void);


unsigned int color[]={0xf800,0x07e0,0x001f,0xffe0,0x0000,0xffff,0x07ff,0xf81f};
//=================================================================================

//ߴʾ

//=================================================================================



#define   HDP	799 //Horizontal Display Period
#define   HT	899 //Horizontal Total
#define   HPS	2  //LLINE Pulse Start Position
#define   LPS	1   //	Horizontal Display Period Start Position
#define   HPW	1   //	LLINE Pulse Width


#define   VDP	479	//Vertical Display Period
#define   VT	499	//Vertical Total
#define   VPS	2	//	LFRAME Pulse Start Position
#define   FPS	1	//Vertical Display Period Start Positio
#define   VPW	1	// LFRAME Pulse Width
//=================================================================================

extern unsigned char zm9[];
extern unsigned char zm8[];
extern unsigned char zm7[];
extern unsigned char zm6[];
extern unsigned char zm5[];
extern unsigned char zm4[];
extern unsigned char zm3[];
extern unsigned char zm2[];
extern unsigned char zm1[];
extern unsigned char zm0[];
extern unsigned char a1[];
extern unsigned char a2[];
extern unsigned char zf2[];
extern unsigned char zf3[];	

unsigned int LCD_RD_data(void);
extern void lcd_rst(void);
void Delay(__IO uint32_t nCount);
void delay_time(unsigned int i);
void SetScrollArea(unsigned int top, unsigned int scroll, unsigned int bottom);
void SetScrollStart(unsigned int line);
void SetTearingCfg(unsigned char state, unsigned char mode);


#define Bank1_LCD_D    ((uint32_t)0x60020000)    //disp Data ram
#define Bank1_LCD_C    ((uint32_t)0x60000000)	 //disp Reg ram


  	#define DISP_ORIENTATION   0//180
	/*********************************************************************
	* Overview: Panel Data Width (R,G,B) in (6,6,6)
	*********************************************************************/
	#define DISP_DATA_WIDTH                 16
	/*********************************************************************
	* Overview: Horizontal and vertical display resolution
	*                  (from the glass datasheet).
	*********************************************************************/
 	#define DISP_HOR_RESOLUTION 800
 	#define DISP_VER_RESOLUTION 480

	/*********************************************************************
	* Overview: Horizontal synchronization timing in pixels
	*                  (from the glass datasheet).
	*********************************************************************/
	#define DISP_HOR_PULSE_WIDTH		1
	#define DISP_HOR_BACK_PORCH			210
	#define DISP_HOR_FRONT_PORCH		45 
	/*********************************************************************
	* Overview: Vertical synchronization timing in lines
	*                  (from the glass datasheet).
	*********************************************************************/
	#define DISP_VER_PULSE_WIDTH		1
	#define DISP_VER_BACK_PORCH			34	
	#define DISP_VER_FRONT_PORCH		10
	
void Delay(__IO uint32_t nCount)
{
  for(; nCount != 0; nCount--);
}

//дĴַ
void LCD_WR_REG(unsigned int index)
{
	*(__IO uint16_t *) (Bank1_LCD_C)= index;

}


//дĴݺ
//룺dbw λ1Ϊ16λ0Ϊ8λ
void LCD_WR_CMD(unsigned int index,unsigned int val)
{	
	*(__IO uint16_t *) (Bank1_LCD_C)= index;	
	*(__IO uint16_t *) (Bank1_LCD_D)= val;
}

unsigned int LCD_RD_data(void){
	unsigned int a=0;
	//a=(*(__IO uint16_t *) (Bank1_LCD_D)); 	//Dummy
	//a= *(__IO uint16_t *) (Bank1_LCD_D);  	//H
	//a=a<<8;
	a=*(__IO uint16_t *) (Bank1_LCD_D); //L

	return(a);	
}


//д16λݺ
void    LCD_WR_Data(unsigned int val)
{   
	*(__IO uint16_t *) (Bank1_LCD_D)= val; 	
}

//void LCD_WR_Data_8(unsigned int val)
//{
//	*(__IO uint16_t *) (Bank1_LCD_D)= val;
//}


//ʼ
void SSD1963_Init(void)
{

	
	/*ssd1963Ĵ*/
	LCD_WR_REG(0x00E2);	
	LCD_WR_Data(0x0023);
	// Set PLL with OSC = 10MHz (hardware)
    // Multiplier N = 35, VCO (>250MHz)= OSC*(N+1), VCO = 360MHz	   
	LCD_WR_Data(0x0001);
	// Divider M = 2, PLL = 360/(M+1) = 120MHz
	LCD_WR_Data(0x0004);
	// Validate M and N values
	delay_time(40);
	LCD_WR_REG(0x00E0);  // PLL enable
	LCD_WR_Data(0x0001);
	delay_time(40);
	LCD_WR_REG(0x00E0);
	LCD_WR_Data(0x0003);
	delay_time(50);
	LCD_WR_REG(0x0001);  // software reset
	delay_time(50);
	LCD_WR_REG(0x00E6);
	LCD_WR_Data(0x0004);
	LCD_WR_Data(0x0093);
	LCD_WR_Data(0x00e0);

	LCD_WR_REG(0x00B0);	//LCD SPECIFICATION
	LCD_WR_Data(0x0000);
	LCD_WR_Data(0x0000);
	LCD_WR_Data((HDP>>8)&0X00FF);  //Set HDP
	LCD_WR_Data(HDP&0X00FF);
    LCD_WR_Data((VDP>>8)&0X00FF);  //Set VDP
	LCD_WR_Data(VDP&0X00FF);
    LCD_WR_Data(0x0000);
	delay_time(50);

	LCD_WR_REG(0x00B4);	//HSYNC
	LCD_WR_Data((HT>>8)&0X00FF);  //Set HT
	LCD_WR_Data(HT&0X00FF);
	LCD_WR_Data((HPS>>8)&0X00FF);  //Set HPS
	LCD_WR_Data(HPS&0X00FF);
	LCD_WR_Data(HPW);			   //Set HPW
	LCD_WR_Data((LPS>>8)&0X00FF);  //Set HPS
	LCD_WR_Data(LPS&0X00FF);
	LCD_WR_Data(0x0000);
	delay_time(50);

	LCD_WR_REG(0x00B6);	//VSYNC
	LCD_WR_Data((VT>>8)&0X00FF);   //Set VT
	LCD_WR_Data(VT&0X00FF);
	LCD_WR_Data((VPS>>8)&0X00FF);  //Set VPS
	LCD_WR_Data(VPS&0X00FF);
	LCD_WR_Data(VPW);			   //Set VPW
	LCD_WR_Data((FPS>>8)&0X00FF);  //Set FPS
	LCD_WR_Data(FPS&0X00FF);
	delay_time(50);

	LCD_WR_REG(0x00BA);
	LCD_WR_Data(0x0005);//0x000F);    //GPIO[3:0] out 1
	delay_time(50);

	LCD_WR_REG(0x00B8);
	LCD_WR_Data(0x0007);    //GPIO3=input, GPIO[2:0]=output
	LCD_WR_Data(0x0001);    //GPIO0 normal
	delay_time(50);

	LCD_WR_REG(0x0036); //rotation
	LCD_WR_Data(0x0008);
	delay_time(50);

	LCD_WR_REG(0x00F0); //pixel data interface
	LCD_WR_Data(0x0003);
	delay_time(50);


	delay_time(50);
	LCD_WR_REG(0x0029); //display on
	delay_time(50);

	LCD_WR_REG(0x00BE); //set PWM for B/L
	LCD_WR_Data(0x0006);
	LCD_WR_Data(0x00ff);
	delay_time(50);
	
	LCD_WR_Data(0x0001);
	LCD_WR_Data(0x00f0);
	LCD_WR_Data(0x0000);
	LCD_WR_Data(0x0000);
	delay_time(50);

	LCD_WR_REG(0x00d0);//ö̬ 
	LCD_WR_Data(0x000d);
	delay_time(50);
   			

}

void LCD_clear(void)
{
    unsigned int l=800,w;

	LCD_WR_REG(0x002A);	
	LCD_WR_Data(0);	    
	LCD_WR_Data(0);
	LCD_WR_Data(HDP>>8);	    
	LCD_WR_Data(HDP&0x00ff);
    LCD_WR_REG(0x002b);	
	LCD_WR_Data(0);	    
	LCD_WR_Data(0);
	LCD_WR_Data(VDP>>8);	    
	LCD_WR_Data(VDP&0x00ff);
	LCD_WR_REG(0x002c);
	
	
	while(l--)
	{
	    for(w=0;w<480;w++)
		{    
          	LCD_WR_Data(0xf800);
		}
	}
}


//ʾ
void LCD_test(void)
{
	unsigned int  temp=0;
	unsigned char *p;
	unsigned long n;
//	unsigned int line=0;
    

	//LCD_WR_CMD(0x20, 0xa4);
    //LCD_WR_CMD(0x21,0x07);

	/*LCD_WR_CMD(0,0x00,0xa4);
	LCD_WR_CMD(0,0x01,0x07);
	LCD_WR_CMD(0,0x02,0);        //0-239
	LCD_WR_CMD(1,0x03,0);        //0-319
	
    LCD_WR_CMD(0,0x04,239);        //0-239
	LCD_WR_CMD(1,0x05,319);        //0-319
	 */
	

	//LCD_WR_REG(0x0E);
		n=0;
	
			LCD_WR_REG(0x002A);	
	        LCD_WR_Data(0);	    
	        LCD_WR_Data(0);
	        LCD_WR_Data(HDP>>8);	    
	        LCD_WR_Data(HDP&0x00ff);
            LCD_WR_REG(0x002b);	
	        LCD_WR_Data(0);	    
	        LCD_WR_Data(0);
	        LCD_WR_Data(VDP>>8);	    
	        LCD_WR_Data(VDP&0x00ff);
	        LCD_WR_REG(0x002c);
	
	
		while(n<256000)
		{
		     //while(1){

		//	temp=(uint16_t)( a2[n]<<8)+a2[n+1];
			temp=0x07e0;
			  //temp++;	
			  //LCD_WR_CMD(0x20, 0xa4);			
			LCD_WR_Data(temp);
		//	if(n<125000)
		//	LCD_WR_Data(0x07e0);
		//	else
		//	 LCD_WR_Data(0x001f);
		
			n=n+2;
			// }
			 //LCD_WR_Data(color1);
	 	}

	
	  // SetScrollArea(0,480,0);
   	  // for(line=0;line<480;line++) 
	  // {
	  // SetScrollStart(line);
	  // Delay(0xffff);
	  // }


	Delay(0xafffff);
	/*
    lcd_wr_zf(0,0,239,319,870,color1,1,&zf3[0]);  
	p=num_pub((color1/10000));
	lcd_wr_zf(0,30,23,61,96,color1,0,p);  
	
	p=num_pub((color1%10000)/1000);
	lcd_wr_zf(24,30,47,61,96,color1,0,p);
	
	p=num_pub(((color1%10000)%1000)/100);
	lcd_wr_zf(48,30,71,61,96,color1,0,p);

	p=num_pub((((color1%10000)%1000)%100)/10);
	lcd_wr_zf(72,30,95,61,96,color1,0,p);

	p=num_pub((color1%10));
	lcd_wr_zf(96,30,119,61,96,color1,0,p);

	color1++; 
	if(color1==65536) color1=0; */ 
	Delay(0xaffff);			
}

void delay_time(u32 Time)
{
   u32 Daly_Time = 0;
	unsigned char i;
	do
	{
		for(i=0;i<50;i++);
		Daly_Time++;
	}
	while(Daly_Time < Time);
}

/*********************************************************************
* Function:  SetScrollArea(SHORT top, SHORT scroll, SHORT bottom)
*
* PreCondition: none
*
* Input: top - Top Fixed Area in number of lines from the top
*				of the frame buffer
*		 scroll - Vertical scrolling area in number of lines
*		 bottom - Bottom Fixed Area in number of lines
*
* Output: none
*
* Side Effects: none
*
* Overview:
*
* Note: Reference: section 9.22 Set Scroll Area, SSD1963 datasheet Rev0.20
********************************************************************/
void SetScrollArea(unsigned int top, unsigned int scroll, unsigned int bottom)
{


//	WriteCommand(CMD_SET_SCROLL_AREA);
//	CS_LAT_BIT = 0;
	LCD_WR_REG(0x33);
	LCD_WR_Data(top>>8);
	LCD_WR_Data(top);
	LCD_WR_Data(scroll>>8);
	LCD_WR_Data(scroll);
	LCD_WR_Data(bottom>>8);
	LCD_WR_Data(bottom);
//	CS_LAT_BIT = 1;	
}

/*********************************************************************
* Function:  void  SetScrollStart(SHORT line)
*
* Overview: First, we need to define the scrolling area by SetScrollArea()
*			before using this function. 
*
* PreCondition: SetScrollArea(SHORT top, SHORT scroll, SHORT bottom)
*
* Input: line - Vertical scrolling pointer (in number of lines) as 
*		 the first display line from the Top Fixed Area defined in SetScrollArea()
*
* Output: none
*
* Note: Example -
*
*		SHORT line=0;
*		SetScrollArea(0,272,0);
*		for(line=0;line<272;line++) {SetScrollStart(line);DelayMs(100);}
*		
*		Code above scrolls the whole page upwards in 100ms interval 
*		with page 2 replacing the first page in scrolling
********************************************************************/
void SetScrollStart(unsigned int line)
{

//	LCD_WR_REG(0x002A);	
//    LCD_WR_Data(0);	  
//	LCD_WR_REG(CMD_SET_SCROLL_START);
	LCD_WR_REG(0x37);
//	CS_LAT_BIT = 0;
	LCD_WR_Data(line>>8);
	LCD_WR_Data(line);	
//	CS_LAT_BIT = 1;
}

/*********************************************************************
* Function:  void  SetTearingCfg(BOOL state, BOOL mode)
*
* Overview: This function enable/disable tearing effect
*
* PreCondition: none
*
* Input: 	BOOL state -	1 to enable
*							0 to disable
*			BOOL mode -		0:  the tearing effect output line consists
*								of V-blanking information only
*							1:	the tearing effect output line consists
*								of both V-blanking and H-blanking info.
* Output: none
*
* Note:
********************************************************************/
void SetTearingCfg(unsigned char state, unsigned char mode)
{


	if(state == 1)
	{
		LCD_WR_REG(0x35);
		//CS_LAT_BIT = 0;
		LCD_WR_Data(mode&0x01);
		//CS_LAT_BIT = 1;
	}
	else
	{
		LCD_WR_REG(0x34);
	}


}




/******************* (C) COPYRIGHT 2009 STMicroelectronics *****END OF FILE****/
